/*
 * MapperGLCanvas.h
 *
 * (c) 2013 Sofian Audry -- info(@)sofianaudry(.)com
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef MAPPERGLCANVAS_H_
#define MAPPERGLCANVAS_H_

#include <wx/wx.h>
#include <wx/glcanvas.h>

#include "Common.h"
#include "Shape.h"

class MapperGLCanvas: public wxGLCanvas {
private:
  static wxGLContext* sharedContext;

public:
  MapperGLCanvas(wxFrame* parent);
  virtual ~MapperGLCanvas() {}

  virtual void Paintit(wxPaintEvent& event);

  virtual Quad& getQuad() = 0;

protected:
  DECLARE_EVENT_TABLE()

  virtual void Render();
  virtual void enterRender();
  virtual void doRender() = 0;
  virtual void exitRender();

private:
  virtual void OnChar(wxKeyEvent& event);
  virtual void OnMouseEvent(wxMouseEvent& event);

};

#endif /* MAPPERGLCANVAS_H_ */
